Summary:        Kernel analysis utility for live systems, netdump, diskdump, kdump, LKCD or mcore dumpfiles
Name:           crash
Version:        8.0.4
Release:        6%{?dist}
License:        GPLv3
URL:            https://crash-utility.github.io
Source0:        https://github.com/crash-utility/crash/archive/refs/tags/%{version}.tar.gz
Source1:        http://ftp.gnu.org/gnu/gdb/gdb-10.2.tar.gz

Patch3001:      lzo_snappy_zstd.patch
Patch3002:      crash-8.0.3_build.patch
Patch3003:      0001-crash-8.0.4-add-support-for-loongarch64.patch
Patch3004:      0002-crash-add-SDEI-stack-resolution.patch
Patch3005:      0003-arm64-fix-a-potential-segfault-when-unwind-frame.patch
Patch3006:      0004-arm64-fix-SDEI-stack-frame-unwind-while-UNW_4_14-is-.patch

ExclusiveArch:  x86_64 aarch64 ppc64le loongarch64
BuildRequires:  gcc gcc-c++ make bison
BuildRequires:  ncurses-devel zlib-devel lzo-devel snappy-devel libzstd-devel wget patch texinfo
Requires:       binutils
Provides:       bundled(libiberty)
Provides:       bundled(gdb) = 10.2

%description
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump packages from Red Hat Linux, the mcore kernel patch
offered by Mission Critical Linux, or the LKCD kernel patch.


%package devel
Summary:        kernel crash analysis utility for live systems, netdump, diskdump, kdump, LKCD or mcore dumpfiles
Requires:       %{name} = %{version}, zlib-devel

%description devel
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump packages from Red Hat Linux, the mcore kernel patch
offered by Mission Critical Linux, or the LKCD kernel patch.


%prep
%autosetup -n %{name}-%{version} -p1


%build
cp %{SOURCE1} .
make RPMPKG="%{version}-%{release}"


%install
%make_install
mkdir -p %{buildroot}%{_mandir}/man8/
mkdir -p %{buildroot}%{_includedir}/%{name}/
cp -p crash.8 %{buildroot}%{_mandir}/man8/crash.8
cp -p defs.h %{buildroot}%{_includedir}/crash/defs.h


%files
%license COPYING3
%doc README
%{_bindir}/crash
%{_mandir}/man8/crash.8*


%files devel
%{_includedir}/*


%changelog
* Wed May 21 2025 Ming Wang <wangming01@loongson.cn> - 8.0.4-6
- Set the NR_CPUS macro in the crash tool to 2048 to match the kernel's value

* Mon Mar 10 2025 huwentao <huwentao@h-partners.com> - 8.0.4-5
- fix a potential segfault when unwind frame

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.4-4
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.4-3
- Rebuilt for loongarch release

* Mon May 27 2024 Pengda Dou <doupengda@loongson.cn> - 8.0.4-2
- [Type] other
- [DESC] add support for loongarch64

* Thu Dec 28 2023 Upgrade Robot <upbot@opencloudos.org> - 8.0.4-1
- Upgrade to version 8.0.4

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.3-3
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Sep 04 2023 cunshunxia <cunshunxia@tencent.com> - 8.0.3-2
- fix glibc 2.38 strlcpy conflicts.

* Mon Jul 03 2023 kianli <kianli@tencent.com> - 8.0.3-1
- Upgrade to 8.0.3 and fix Source0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.2-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Feb 28 2023 rockerzhu <rockerzhu@tencent.com> - 8.0.2-1
- Update to 8.0.2

* Thu Apr 14 2022 Zhongze Hu <joshuahu@tencent.com> - 8.0.0-1
- Initial build
